VTK: vtkMultiThreader Class Reference

| VTK 9.3.1

Classes | Public Types | Public Member Functions | Static Public Member Functions | Protected Member Functions | Protected Attributes | List of all members
vtkMultiThreader Class Reference

A class for performing multithreaded execution. More...

`#include <vtkMultiThreader.h>`

Inheritance diagram for vtkMultiThreader:
[legend]
Collaboration diagram for vtkMultiThreader:
[legend]

## Classes
class | ThreadInfo
| This is the structure that is passed to the thread that is created from the SingleMethodExecute, MultipleMethodExecute or the SpawnThread method. More...

## Public Types
typedef vtkObject | Superclass

## Public Member Functions
virtual vtkTypeBool | IsA (const char *type)
| Return 1 if this class is the same type of (or a subclass of) the named class. More...
vtkMultiThreader * | NewInstance () const
void | PrintSelf (ostream &os, vtkIndent indent) override
| Methods invoked by print to print information about the object including superclasses. More...
void | SingleMethodExecute ()
| Execute the SingleMethod (as define by SetSingleMethod) using this->NumberOfThreads threads. More...
void | MultipleMethodExecute ()
| Execute the MultipleMethods (as define by calling SetMultipleMethod for each of the required this->NumberOfThreads methods) using this->NumberOfThreads threads. More...
void | SetSingleMethod (vtkThreadFunctionType, void *data)
| Set the SingleMethod to f() and the UserData field of the ThreadInfo that is passed to it will be data. More...
void | SetMultipleMethod (int index, vtkThreadFunctionType, void *data)
| Set the MultipleMethod at the given index to f() and the UserData field of the ThreadInfo that is passed to it will be data. More...
int | SpawnThread (vtkThreadFunctionType, void *data)
| Create a new thread for the given function. More...
void | TerminateThread (int threadId)
| Terminate the thread that was created with a SpawnThreadExecute() More...
vtkTypeBool | IsThreadActive (int threadId)
| Determine if a thread is still active. More...
virtual void | SetNumberOfThreads (int)
| Get/Set the number of threads to create. More...
virtual int | GetNumberOfThreads ()
| Get/Set the number of threads to create. More...
Public Member Functions inherited from vtkObject
| vtkBaseTypeMacro (vtkObject, vtkObjectBase)
virtual void | DebugOn ()
| Turn debugging output on. More...
virtual void | DebugOff ()
| Turn debugging output off. More...
bool | GetDebug ()
| Get the value of the debug flag. More...
void | SetDebug (bool debugFlag)
| Set the value of the debug flag. More...
virtual void | Modified ()
| Update the modification time for this object. More...
virtual vtkMTimeType | GetMTime ()
| Return this object's modified time. More...
void | PrintSelf (ostream &os, vtkIndent indent) override
| Methods invoked by print to print information about the object including superclasses. More...
void | RemoveObserver (unsigned long tag)
void | RemoveObservers (unsigned long event)
void | RemoveObservers (const char *event)
void | RemoveAllObservers ()
vtkTypeBool | HasObserver (unsigned long event)
vtkTypeBool | HasObserver (const char *event)
vtkTypeBool | InvokeEvent (unsigned long event)
vtkTypeBool | InvokeEvent (const char *event)
std::string | GetObjectDescription () const override
| The object description printed in messages and PrintSelf output. More...
unsigned long | AddObserver (unsigned long event, vtkCommand *, float priority=0.0f)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
unsigned long | AddObserver (const char *event, vtkCommand *, float priority=0.0f)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
vtkCommand * | GetCommand (unsigned long tag)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
void | RemoveObserver (vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
void | RemoveObservers (unsigned long event, vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
void | RemoveObservers (const char *event, vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
vtkTypeBool | HasObserver (unsigned long event, vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
vtkTypeBool | HasObserver (const char *event, vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
template<class U , class T >
unsigned long | AddObserver (unsigned long event, U observer, void(T::*callback)(), float priority=0.0f)
| Overloads to AddObserver that allow developers to add class member functions as callbacks for events. More...
template<class U , class T >
unsigned long | AddObserver (unsigned long event, U observer, void(T::*callback)(vtkObject *, unsigned long, void *), float priority=0.0f)
| Overloads to AddObserver that allow developers to add class member functions as callbacks for events. More...
template<class U , class T >
unsigned long | AddObserver (unsigned long event, U observer, bool(T::*callback)(vtkObject *, unsigned long, void *), float priority=0.0f)
| Allow user to set the AbortFlagOn() with the return value of the callback method. More...
vtkTypeBool | InvokeEvent (unsigned long event, void *callData)
| This method invokes an event and return whether the event was aborted or not. More...
vtkTypeBool | InvokeEvent (const char *event, void *callData)
| This method invokes an event and return whether the event was aborted or not. More...
virtual void | SetObjectName (const std::string &objectName)
| Set/get the name of this object for reporting purposes. More...
virtual std::string | GetObjectName () const
| Set/get the name of this object for reporting purposes. More...
Public Member Functions inherited from vtkObjectBase
const char * | GetClassName () const
| Return the class name as a string. More...
virtual vtkIdType | GetNumberOfGenerationsFromBase (const char *name)
| Given the name of a base class of this class type, return the distance of inheritance between this class type and the named class (how many generations of inheritance are there between this class and the named class). More...
virtual void | Delete ()
| Delete a VTK object. More...
virtual void | FastDelete ()
| Delete a reference to this object. More...
void | InitializeObjectBase ()
void | Print (ostream &os)
| Print an object to an ostream. More...
virtual void | Register (vtkObjectBase *o)
| Increase the reference count (mark as used by another object). More...
virtual void | UnRegister (vtkObjectBase *o)
| Decrease the reference count (release by another object). More...
int | GetReferenceCount ()
| Return the current reference count of this object. More...
void | SetReferenceCount (int)
| Sets the reference count. More...
bool | GetIsInMemkind () const
| A local state flag that remembers whether this object lives in the normal or extended memory space. More...
virtual void | PrintHeader (ostream &os, vtkIndent indent)
| Methods invoked by print to print information about the object including superclasses. More...
virtual void | PrintTrailer (ostream &os, vtkIndent indent)
| Methods invoked by print to print information about the object including superclasses. More...
virtual bool | UsesGarbageCollector () const
| Indicate whether the class uses `vtkGarbageCollector` or not. More...

## Static Public Member Functions
static vtkMultiThreader * | New ()
static vtkTypeBool | IsTypeOf (const char *type)
static vtkMultiThreader * | SafeDownCast (vtkObjectBase *o)
static vtkMultiThreaderIDType | GetCurrentThreadID ()
| Get the thread identifier of the calling thread. More...
static vtkTypeBool | ThreadsEqual (vtkMultiThreaderIDType t1, vtkMultiThreaderIDType t2)
| Check whether two thread identifiers refer to the same thread. More...
static int | GetGlobalStaticMaximumNumberOfThreads ()
| Set/Get the maximum number of threads VTK was allocated to support. More...
static void | SetGlobalMaximumNumberOfThreads (int val)
| Set/Get the maximum number of threads to use when multithreading. More...
static int | GetGlobalMaximumNumberOfThreads ()
| Set/Get the maximum number of threads to use when multithreading. More...
static void | SetGlobalDefaultNumberOfThreads (int val)
| Set/Get the value which is used to initialize the NumberOfThreads in the constructor. More...
static int | GetGlobalDefaultNumberOfThreads ()
| Set/Get the value which is used to initialize the NumberOfThreads in the constructor. More...
Static Public Member Functions inherited from vtkObject
static vtkObject * | New ()
| Create an object with Debug turned off, modified time initialized to zero, and reference counting on. More...
static void | BreakOnError ()
| This method is called when vtkErrorMacro executes. More...
static void | SetGlobalWarningDisplay (vtkTypeBool val)
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
static void | GlobalWarningDisplayOn ()
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
static void | GlobalWarningDisplayOff ()
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
static vtkTypeBool | GetGlobalWarningDisplay ()
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
Static Public Member Functions inherited from vtkObjectBase
static vtkTypeBool | IsTypeOf (const char *name)
| Return 1 if this class type is the same type of (or a subclass of) the named class. More...
static vtkIdType | GetNumberOfGenerationsFromBaseType (const char *name)
| Given a the name of a base class of this class type, return the distance of inheritance between this class type and the named class (how many generations of inheritance are there between this class and the named class). More...
static vtkObjectBase * | New ()
| Create an object with Debug turned off, modified time initialized to zero, and reference counting on. More...
static void | SetMemkindDirectory (const char *directoryname)
| The name of a directory, ideally mounted -o dax, to memory map an extended memory space within. More...
static bool | GetUsingMemkind ()
| A global state flag that controls whether vtkObjects are constructed in the usual way (the default) or within the extended memory space. More...

## Protected Member Functions
virtual vtkObjectBase * | NewInstanceInternal () const
| vtkMultiThreader ()
| ~vtkMultiThreader () override
Protected Member Functions inherited from vtkObject
| vtkObject ()
| ~vtkObject () override
void | RegisterInternal (vtkObjectBase *, vtkTypeBool check) override
void | UnRegisterInternal (vtkObjectBase *, vtkTypeBool check) override
void | InternalGrabFocus (vtkCommand *mouseEvents, vtkCommand *keypressEvents=nullptr)
| These methods allow a command to exclusively grab all events. More...
void | InternalReleaseFocus ()
| These methods allow a command to exclusively grab all events. More...
Protected Member Functions inherited from vtkObjectBase
| vtkObjectBase ()
virtual | ~vtkObjectBase ()
virtual void | ReportReferences (vtkGarbageCollector *)
| vtkObjectBase (const vtkObjectBase &)
void | operator= (const vtkObjectBase &)

## Protected Attributes
int | NumberOfThreads
ThreadInfo | ThreadInfoArray [VTK_MAX_THREADS]
vtkThreadFunctionType | SingleMethod
vtkThreadFunctionType | MultipleMethod [VTK_MAX_THREADS]
int | SpawnedThreadActiveFlag [VTK_MAX_THREADS]
std::mutex * | SpawnedThreadActiveFlagLock [VTK_MAX_THREADS]
vtkThreadProcessIDType | SpawnedThreadProcessID [VTK_MAX_THREADS]
ThreadInfo | SpawnedThreadInfoArray [VTK_MAX_THREADS]
void * | SingleData
void * | MultipleData [VTK_MAX_THREADS]
Protected Attributes inherited from vtkObject
bool | Debug
vtkTimeStamp | MTime
vtkSubjectHelper * | SubjectHelper
std::string | ObjectName
Protected Attributes inherited from vtkObjectBase
std::atomic< int32_t > | ReferenceCount
vtkWeakPointerBase ** | WeakPointers

## Additional Inherited Members
Static Protected Member Functions inherited from vtkObjectBase
static vtkMallocingFunction | GetCurrentMallocFunction ()
static vtkReallocingFunction | GetCurrentReallocFunction ()
static vtkFreeingFunction | GetCurrentFreeFunction ()
static vtkFreeingFunction | GetAlternateFreeFunction ()

## Detailed Description

A class for performing multithreaded execution.

vtkMultithreader is a class that provides support for multithreaded execution using pthreads on POSIX systems, or Win32 threads on Windows. This class can be used to execute a single method on multiple threads, or to specify a method per thread.

Examples:
  vtkMultiThreader (Examples)

Tests:
  vtkMultiThreader (Tests)

Definition at line 71 of file vtkMultiThreader.h.

## Member Typedef Documentation

## ◆ Superclass

typedef vtkObject vtkMultiThreader::Superclass

Definition at line 76 of file vtkMultiThreader.h.

## Constructor & Destructor Documentation

## ◆ vtkMultiThreader()

vtkMultiThreader::vtkMultiThreader | ( |  | ) |
| protected

## ◆ ~vtkMultiThreader()

vtkMultiThreader::~vtkMultiThreader | ( |  | ) |
| overrideprotected

## Member Function Documentation

## ◆ New()

static vtkMultiThreader* vtkMultiThreader::New | ( |  | ) |
| static

## ◆ IsTypeOf()

static vtkTypeBool vtkMultiThreader::IsTypeOf | ( | const char * | type | ) |
| static

## ◆ IsA()

virtual vtkTypeBool vtkMultiThreader::IsA | ( | const char * | name | ) |
| virtual

Return 1 if this class is the same type of (or a subclass of) the named class.

Returns 0 otherwise. This method works in combination with vtkTypeMacro found in vtkSetGet.h.

Reimplemented from vtkObjectBase.

## ◆ SafeDownCast()

static vtkMultiThreader* vtkMultiThreader::SafeDownCast | ( | vtkObjectBase * | o | ) |
| static

## ◆ NewInstanceInternal()

virtual vtkObjectBase* vtkMultiThreader::NewInstanceInternal | ( |  | ) | const
| protectedvirtual

## ◆ NewInstance()

vtkMultiThreader* vtkMultiThreader::NewInstance | ( |  | ) | const

## ◆ PrintSelf()

void vtkMultiThreader::PrintSelf | ( | ostream & | os,
|  | vtkIndent | indent
| ) |  |
| overridevirtual

Methods invoked by print to print information about the object including superclasses.

Typically not called by the user (use Print() instead) but used in the hierarchical print process to combine the output of several classes.

Reimplemented from vtkObjectBase.

## ◆ SetNumberOfThreads()

virtual void vtkMultiThreader::SetNumberOfThreads | ( | int |  | ) |
| virtual

Get/Set the number of threads to create.

It will be clamped to the range 1 - VTK_MAX_THREADS, so the caller of this method should check that the requested number of threads was accepted.

## ◆ GetNumberOfThreads()

virtual int vtkMultiThreader::GetNumberOfThreads | ( |  | ) |
| virtual

Get/Set the number of threads to create.

It will be clamped to the range 1 - VTK_MAX_THREADS, so the caller of this method should check that the requested number of threads was accepted.

## ◆ GetGlobalStaticMaximumNumberOfThreads()

static int vtkMultiThreader::GetGlobalStaticMaximumNumberOfThreads | ( |  | ) |
| static

Set/Get the maximum number of threads VTK was allocated to support.

## ◆ SetGlobalMaximumNumberOfThreads()

static void vtkMultiThreader::SetGlobalMaximumNumberOfThreads | ( | int | val | ) |
| static

Set/Get the maximum number of threads to use when multithreading.

This limits and overrides any other settings for multithreading. A value of zero indicates no limit.

## ◆ GetGlobalMaximumNumberOfThreads()

static int vtkMultiThreader::GetGlobalMaximumNumberOfThreads | ( |  | ) |
| static

Set/Get the maximum number of threads to use when multithreading.

This limits and overrides any other settings for multithreading. A value of zero indicates no limit.

## ◆ SetGlobalDefaultNumberOfThreads()

static void vtkMultiThreader::SetGlobalDefaultNumberOfThreads | ( | int | val | ) |
| static

Set/Get the value which is used to initialize the NumberOfThreads in the constructor.

Initially this default is set to the number of processors or VTK_MAX_THREADS (which ever is less).

## ◆ GetGlobalDefaultNumberOfThreads()

static int vtkMultiThreader::GetGlobalDefaultNumberOfThreads | ( |  | ) |
| static

Set/Get the value which is used to initialize the NumberOfThreads in the constructor.

Initially this default is set to the number of processors or VTK_MAX_THREADS (which ever is less).

## ◆ SingleMethodExecute()

void vtkMultiThreader::SingleMethodExecute | ( |  | ) |

Execute the SingleMethod (as define by SetSingleMethod) using this->NumberOfThreads threads.

## ◆ MultipleMethodExecute()

void vtkMultiThreader::MultipleMethodExecute | ( |  | ) |

Execute the MultipleMethods (as define by calling SetMultipleMethod for each of the required this->NumberOfThreads methods) using this->NumberOfThreads threads.

## ◆ SetSingleMethod()

void vtkMultiThreader::SetSingleMethod | ( | vtkThreadFunctionType | ,
|  | void * | data
| ) |  |

Set the SingleMethod to f() and the UserData field of the ThreadInfo that is passed to it will be data.

This method (and all the methods passed to SetMultipleMethod) must be of type vtkThreadFunctionType and must take a single argument of type void *.

## ◆ SetMultipleMethod()

void vtkMultiThreader::SetMultipleMethod | ( | int | index,
|  | vtkThreadFunctionType | ,
|  | void * | data
| ) |  |

Set the MultipleMethod at the given index to f() and the UserData field of the ThreadInfo that is passed to it will be data.

## ◆ SpawnThread()

int vtkMultiThreader::SpawnThread | ( | vtkThreadFunctionType | ,
|  | void * | data
| ) |  |

Create a new thread for the given function.

Return a thread id which is a number between 0 and VTK_MAX_THREADS - 1. This id should be used to kill the thread at a later time.

## ◆ TerminateThread()

void vtkMultiThreader::TerminateThread | ( | int | threadId | ) |

Terminate the thread that was created with a SpawnThreadExecute()

## ◆ IsThreadActive()

vtkTypeBool vtkMultiThreader::IsThreadActive | ( | int | threadId | ) |

Determine if a thread is still active.

## ◆ GetCurrentThreadID()

static vtkMultiThreaderIDType vtkMultiThreader::GetCurrentThreadID | ( |  | ) |
| static

Get the thread identifier of the calling thread.

## ◆ ThreadsEqual()

static vtkTypeBool vtkMultiThreader::ThreadsEqual | ( | vtkMultiThreaderIDType | t1,
|  | vtkMultiThreaderIDType | t2
| ) |  |
| static

Check whether two thread identifiers refer to the same thread.

## Member Data Documentation

## ◆ NumberOfThreads

int vtkMultiThreader::NumberOfThreads
| protected

Definition at line 202 of file vtkMultiThreader.h.

## ◆ ThreadInfoArray

ThreadInfo vtkMultiThreader::ThreadInfoArray[VTK_MAX_THREADS]
| protected

Definition at line 207 of file vtkMultiThreader.h.

## ◆ SingleMethod

vtkThreadFunctionType vtkMultiThreader::SingleMethod
| protected

Definition at line 210 of file vtkMultiThreader.h.

## ◆ MultipleMethod

vtkThreadFunctionType vtkMultiThreader::MultipleMethod[VTK_MAX_THREADS]
| protected

Definition at line 211 of file vtkMultiThreader.h.

## ◆ SpawnedThreadActiveFlag

int vtkMultiThreader::SpawnedThreadActiveFlag[VTK_MAX_THREADS]
| protected

Definition at line 215 of file vtkMultiThreader.h.

## ◆ SpawnedThreadActiveFlagLock

std::mutex* vtkMultiThreader::SpawnedThreadActiveFlagLock[VTK_MAX_THREADS]
| protected

Definition at line 216 of file vtkMultiThreader.h.

## ◆ SpawnedThreadProcessID

vtkThreadProcessIDType vtkMultiThreader::SpawnedThreadProcessID[VTK_MAX_THREADS]
| protected

Definition at line 217 of file vtkMultiThreader.h.

## ◆ SpawnedThreadInfoArray

ThreadInfo vtkMultiThreader::SpawnedThreadInfoArray[VTK_MAX_THREADS]
| protected

Definition at line 218 of file vtkMultiThreader.h.

## ◆ SingleData

void* vtkMultiThreader::SingleData
| protected

Definition at line 221 of file vtkMultiThreader.h.

## ◆ MultipleData

void* vtkMultiThreader::MultipleData[VTK_MAX_THREADS]
| protected

Definition at line 222 of file vtkMultiThreader.h.

The documentation for this class was generated from the following file:

- Common/Core/vtkMultiThreader.h